import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

/**
 * Ein primitives Klickspiel.
 * Die angezeigten Formen ndern beim Anklicken ihre Farbe.
 * 
 * @author Bernd Gramlich
 * @version 2013-05-06
 */
public class Klickspiel implements MouseListener
{
    /*
     * Die Formen.
     */
    private Ellipse oval;
    private Kreissektor tortenstueck;
    private Rechteck kasten;

    /**
     * Konstruktor.
     * Erzeuge die Formen und warte auf Mausereignisse der Leinwand.
     */
    public Klickspiel ()
    {
        oval = new Ellipse ();
        oval.setzeBreite (200);
        oval.setzeHoehe (100);
        oval.setzeFarbe ("rot");
        oval.setzePosition (50, 50);
        oval.werdeSichtbar ();
        
        tortenstueck = new Kreissektor ();
        tortenstueck.setzeRadius (50);
        tortenstueck.setzeAnfangswinkel (120);
        tortenstueck.setzeGesamtwinkel (240);
        tortenstueck.setzeFarbe ("gelb");
        tortenstueck.setzePosition (100, 200);
        tortenstueck.werdeSichtbar ();
        
        kasten = new Rechteck ();
        kasten.setzeBreite (200);
        kasten.setzeHoehe (100);
        kasten.setzeFarbe ("gruen");
        kasten.setzePosition  (50, 350);
        kasten.werdeSichtbar ();
        
        Leinwand.gibLeinwand ().gibZeichenflaeche ().addMouseListener (this);
    }
    
    /**
     * Reagiere auf Mausklick.
     */
    public void mouseClicked (MouseEvent ereignis)
    {
        System.out.println ("Geklickt auf " + ereignis.getPoint ()); 
        
        String alteFarbe;
        
        if (oval.enthaelt (ereignis.getPoint ()))
        {
            alteFarbe = oval.gibFarbe ();
            
            if ("rot" == alteFarbe)
            {
                oval.setzeFarbe ("gelb");
            }
            else if ("gelb" == alteFarbe)
            {
                oval.setzeFarbe ("grn");
            }
            else if ("grn" == alteFarbe)
            {
                oval.setzeFarbe ("rot");
            }
        }
        
        if (tortenstueck.enthaelt (ereignis.getPoint ()))
        {
            alteFarbe = tortenstueck.gibFarbe ();
            
            if ("rot" == alteFarbe)
            {
                tortenstueck.setzeFarbe ("gelb");
            }
            else if ("gelb" == alteFarbe)
            {
                tortenstueck.setzeFarbe ("grn");
            }
            else if ("grn" == alteFarbe)
            {
                tortenstueck.setzeFarbe ("rot");
            }
        }
        
        if (kasten.enthaelt (ereignis.getPoint ()))
        {
            alteFarbe = kasten.gibFarbe ();
            
            if ("rot" == alteFarbe)
            {
                kasten.setzeFarbe ("gelb");
            }
            else if ("gelb" == alteFarbe)
            {
                kasten.setzeFarbe ("grn");
            }
            else if ("grn" == alteFarbe)
            {
                kasten.setzeFarbe ("rot");
            }
        }
    }

    /**
     * Reagiere auf das Drcken einer Maustaste.
     */
    public void mousePressed (MouseEvent ereignis)
    {
        System.out.println ("Gedrckt.");
    }
    
    /**
     * Reagiere auf das Loslassen einer Maustaste.
     */
    public void mouseReleased (MouseEvent ereignis)
    {
        System.out.println ("Losgelassen.");
    }
    
    /**
     * Reagiere darauf, dass der Mauszeiger die Leinwand betritt.
     */
    public void mouseEntered (MouseEvent ereignis)
    {
        System.out.println ("Herein.");
    }
    
    
    /**
     * Reagiere darauf, dass der Mauszeiger die Leinwand verlsst.
     */
    public void mouseExited (MouseEvent ereignis)
    {
        System.out.println ("Hinaus.");
    }
}
